package com.tanpu.community.manager;

import com.tanpu.community.api.beans.qo.FollowQo;
import com.tanpu.community.dao.entity.community.HomePageEntity;
import com.tanpu.community.service.FansRelService;
import com.tanpu.community.service.HomePageService;
import com.tanpu.community.util.ConvertUtil;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.List;
import java.util.stream.Collectors;

@Service
public class HomePageManager {

    @Autowired
    private FansRelService fansRelService;

    @Resource
    private HomePageService homePageService;

    public List<FollowQo> queryIdolsByFollowerId(String followerId) {
        List<String> idolIds = fansRelService.queryFansByFollowerId(followerId);
        List<HomePageEntity> list = homePageService.selectListByUserIds(idolIds);
        return list.stream().map(ConvertUtil::homePageEntity2FollowQo).collect(Collectors.toList());
    }

    public List<FollowQo> queryFansByIdolId(String idolId) {
        List<String> fanIds = fansRelService.queryFansByIdolId(idolId);
        List<HomePageEntity> list = homePageService.selectListByUserIds(fanIds);
        return list.stream().map(ConvertUtil::homePageEntity2FollowQo).collect(Collectors.toList());
    }

    public void addIdol(String idolId, String followerId) {
        fansRelService.addFans(idolId, followerId);
    }
}
